/*
 * Created by DocJava, Inc.
 * User: lyon
 * Date: Mar 3, 2003
 * Time: 5:45:44 PM
 */
package sound.recorder;

import gui.In;
import j2d.ImageUtils;
import j2d.ShortImageBean;
import j2d.ImagePanel;
import j2d.color.IndexImageBean;


import javax.swing.*;
import java.awt.*;

public class SpectrogramFrame extends JFrame {
    private IndexImageBean iib =
            getIndexImageBean();

    public static IndexImageBean getIndexImageBean() {
        try {
            return new IndexImageBean(new ShortImageBean(//getImage()
                    ImageUtils.captureWholeScreen()));
        } catch (AWTException e) {
            In.message(e);

        }
        return null;
    }

    // private ImageProcessButton ip =
    //        new ImageProcessButton(iib.getImage());
    private ImagePanel ip = new ImagePanel(iib.getImage());

    public void incrementImage() {
        iib.add((byte) 1);
        //ip.setImage(iib.getImage());
        ip.setImage(iib.getImage());
    }

    public static void main(String[] args) {
        new SpectrogramFrame();
        //todo create a graph of the spectrogram
        //graphics.grapher.Main.main(args);
    }

    public static short getRandom() {
        return (short) (Math.random() * 255);
    }

    public Image getIndexImage() {
        IndexImageBean iib = new IndexImageBean(new ShortImageBean(getImage()));
        return iib.getImage();
    }

    public Image getImage() {
        ShortImageBean sib = new ShortImageBean(400, 400);
        short r[][] = sib.getR();
        short g[][] = sib.getG();
        short b[][] = sib.getB();
        for (int x = 0; x < r.length; x++)
            for (int y = 0; y < r[0].length; y++) {
                int xc = x - 200;
                int yc = y - 200;
                if ((xc * xc + yc * yc) < 10000) {
                    r[x][y] = getRandom();
                    g[x][y] = getRandom();
                    b[x][y] = getRandom();
                }
            }
        return sib.getImage();
    }

    public SpectrogramFrame() {
        Container c = super.getContentPane();
        gui.layouts.PreferredSizeGridLayout
                lo = new gui.layouts.PreferredSizeGridLayout(0, 1);
        lo.setBoundableInterface(new
                gui.layouts.AspectBoundable());

        c.setLayout(lo);


        c.add(ip);
        setSize(200, 200);
        setDefaultCloseOperation(HIDE_ON_CLOSE);
        setVisible(true);
        for (; true;) {
            incrementImage();
            try {
                Thread.sleep(10);
            } catch (InterruptedException e) {
                In.message(e);

            }
        }

    }
}
